Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
Botan::ECIES_KA_Params Class Reference

`#include <ecies.h>`

Inheritance diagram for Botan::ECIES_KA_Params:

## Public Member Functions
bool | check_mode () const
bool | cofactor_mode () const
PointGFp::Compression_Type | compression_type () const
const EC_Group & | domain () const
| ECIES_KA_Params (const EC_Group &domain, const std::string &kdf_spec, size_t length, PointGFp::Compression_Type compression_type, ECIES_Flags flags)
| ECIES_KA_Params (const ECIES_KA_Params &)=default
const std::string & | kdf_spec () const
bool | old_cofactor_mode () const
ECIES_KA_Params & | operator= (const ECIES_KA_Params &)=default
size_t | secret_length () const
bool | single_hash_mode () const
virtual | ~ECIES_KA_Params ()=default

## Detailed Description

Parameters for ECIES secret derivation

Definition at line 58 of file ecies.h.

## Constructor & Destructor Documentation

Botan::ECIES_KA_Params::ECIES_KA_Params | ( | const EC_Group & | domain,
|  | const std::string & | kdf_spec,
|  | size_t | length,
|  | PointGFp::Compression_Type | compression_type,
|  | ECIES_Flags | flags
| ) |  |

Parameters

  domain | ec domain parameters of the involved ec keys
  kdf_spec | name of the key derivation function
  length | length of the secret to be derived
  compression_type | format of encoded keys (affects the secret derivation if single_hash_mode is used)
  flags | options, see documentation of ECIES_Flags

Definition at line 174 of file ecies.cpp.

175 :
176 m_domain(domain),
177 m_kdf_spec(kdf_spec),
178 m_length(length),
179 m_compression_mode(compression_type),
180 m_flags(flags)
181 {
182 }
Botan::PKCS11::flags
Flags flags(Flag flags)
Definition: p11.h:858
Botan::ECIES_KA_Params::domain
const EC_Group & domain() const
Definition: ecies.h:75
Botan::ECIES_KA_Params::kdf_spec
const std::string & kdf_spec() const
Definition: ecies.h:110
Botan::ECIES_KA_Params::compression_type
PointGFp::Compression_Type compression_type() const
Definition: ecies.h:105

Botan::ECIES_KA_Params::ECIES_KA_Params | ( | const ECIES_KA_Params & |  | ) |
| default

virtual Botan::ECIES_KA_Params::~ECIES_KA_Params | ( |  | ) |
| virtual default

## Member Function Documentation

bool Botan::ECIES_KA_Params::check_mode | ( |  | ) | const
| inline

Definition at line 100 of file ecies.h.

References Botan::CHECK_MODE.

Referenced by Botan::ECIES_Decryptor::ECIES_Decryptor(), and Botan::ECIES_System_Params::ECIES_System_Params().

101 {
102 return (m_flags & ECIES_Flags::CHECK_MODE) == ECIES_Flags::CHECK_MODE;
103 }
Botan::ECIES_Flags::CHECK_MODE
(decryption only) if set: test if the (ephemeral) public key is on the curve

bool Botan::ECIES_KA_Params::cofactor_mode | ( |  | ) | const
| inline

Definition at line 90 of file ecies.h.

References Botan::COFACTOR_MODE.

Referenced by Botan::ECIES_System_Params::ECIES_System_Params().

91 {
92 return (m_flags & ECIES_Flags::COFACTOR_MODE) == ECIES_Flags::COFACTOR_MODE;
93 }
Botan::ECIES_Flags::COFACTOR_MODE
(decryption only) if set: use cofactor multiplication during (ecdh) key agreement ...

PointGFp::Compression_Type Botan::ECIES_KA_Params::compression_type | ( |  | ) | const
| inline

Definition at line 105 of file ecies.h.

Referenced by Botan::ECIES_KA_Operation::derive_secret(), and Botan::ECIES_Encryptor::ECIES_Encryptor().

106 {
107 return m_compression_mode;
108 }

const EC_Group& Botan::ECIES_KA_Params::domain | ( |  | ) | const
| inline

Definition at line 75 of file ecies.h.

Referenced by Botan::ECIES_KA_Operation::derive_secret(), Botan::ECIES_Decryptor::ECIES_Decryptor(), and Botan::ECIES_Encryptor::ECIES_Encryptor().

76 {
77 return m_domain;
78 }

const std::string& Botan::ECIES_KA_Params::kdf_spec | ( |  | ) | const
| inline

Definition at line 110 of file ecies.h.

Referenced by Botan::ECIES_KA_Operation::derive_secret().

111 {
112 return m_kdf_spec;
113 }

bool Botan::ECIES_KA_Params::old_cofactor_mode | ( |  | ) | const
| inline

Definition at line 95 of file ecies.h.

References Botan::OLD_COFACTOR_MODE.

Referenced by Botan::ECIES_KA_Operation::derive_secret(), and Botan::ECIES_System_Params::ECIES_System_Params().

96 {
97 return (m_flags & ECIES_Flags::OLD_COFACTOR_MODE) == ECIES_Flags::OLD_COFACTOR_MODE;
98 }
Botan::ECIES_Flags::OLD_COFACTOR_MODE
if set: use ecdhc instead of ecdh

ECIES_KA_Params& Botan::ECIES_KA_Params::operator= | ( | const ECIES_KA_Params & |  | ) |
| default

size_t Botan::ECIES_KA_Params::secret_length | ( |  | ) | const
| inline

Definition at line 80 of file ecies.h.

Referenced by Botan::ECIES_KA_Operation::derive_secret().

81 {
82 return m_length;
83 }

bool Botan::ECIES_KA_Params::single_hash_mode | ( |  | ) | const
| inline

Definition at line 85 of file ecies.h.

References Botan::SINGLE_HASH_MODE.

Referenced by Botan::ECIES_KA_Operation::derive_secret().

86 {
87 return (m_flags & ECIES_Flags::SINGLE_HASH_MODE) == ECIES_Flags::SINGLE_HASH_MODE;
88 }
Botan::ECIES_Flags::SINGLE_HASH_MODE
if set: prefix the input of the (ecdh) key agreement with the encoded (ephemeral) public key ...

The documentation for this class was generated from the following files:

- src/lib/pubkey/ecies/ecies.h
- src/lib/pubkey/ecies/ecies.cpp